module StatisticalMethods
  module SummaryStatistic
    module Location
      class Median
        def initialize(array)
          @array = array
          @sorted = @array.sort
          @number = @array.size
        end

        def find
          return if @array.empty?
          upper = @number / 2
          lower = @number.odd? ? upper : upper - 1
          (@sorted[lower] + @sorted[upper]) / 2.0
        end
      end
    end
  end
end
