module StatisticalMethods
  module SummaryStatistic
    module Location
      class Mode
        def initialize(array)
          @array = array
        end

        def find
          return if @array.empty?
          hash = @array.group_by_count
          max = hash.values.max
          hash.keep_if { |_key, value| value == max }.keys
        end
      end
    end
  end
end
